
default:
    image: "rust:latest"
    before_script:
        - rustup show

variables:
    CACHE_FALLBACK_KEY: fallback-key


workflow:
    rules:
        - if: $CI_PIPELINE_SOURCE == "merge_request_event"

stages:
    - build
    - test

build:debug: 
    stage: build
    script:
        - cargo build --workspace
    cache:
        key: "$CI_COMMIT_REF_SLUG"
        paths:
            - target
            - /home/runner/.cargo

test:format:
    stage: test
    script: 
        - echo "Format code"
        - cargo fmt -- --check

test:lint:
    stage: test
    script:
        - echo "Run Clippy"
        - cargo clippy -- -W clippy::pedantic -D warnings

test:unit:
    stage: test
    script:
        - echo "Test workspace"
        - rustc --version && cargo --version 
        - cargo test --workspace --verbose